      SUBROUTINE CFGAMI(CFGI,A,X)
C
C Subroutine to calculate the incomplete gamma function
C by continued fraction expansion.
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C Find natural logarithm of gamma(x).
      ALG=ALOGAM(A)
C Set maximum number of terms.
      ITER=100
C Set initial value of continued fraction.
      CFOLD=0.D0
C Set initial valus of even and odd sequences a and b.
      AE=0.D0
      AO=1.D0
      BE=1.D0
      BO=0.D0
C Set initial values of even and odd sequences a and b.
      AAE=1.D0-A
      AAO=1.D0
      BBE=1.D0
      BBO=X
C Evaluate continued fraction, first by odd sequences, then by even.
      DO 10 N=1,ITER
C Calculate odd a and b.
        AO=BBO*AE+AAO*AO
        BO=BBO*BE+AAO*BO
        CF=AO/BO
C Test for convergence.
        IF(CF.EQ.CFOLD) GO TO 11
C Store old CF.
        CFOLD=CF
C Update odd sequence a.
        IF(N.GT.1)AA0=AA0+1.D0
C Calculate even a and b.
        AE=BBE*AO+AAE*AE
        BE=BBE*BO+AAE*BE
        CF=AE/BE
C Update even sequence a.
        AAE=AAE+1.D0
C Test for convergence.
        IF(CF.EQ.CFOLD) GO TO 11
C Store old CF.
        CFOLD=CF
 10   CONTINUE
      PAUSE 'A too large or X too small.'
 11   CFGI=1.D0-DEXP(-X+A*DLOG(X)-ALG)*CF
      RETURN
      END 
