C                    Programme NUTRES.FOR
C
C Programme NUTRES.FOR removes the 18.6-yr term, the 9.3-yr term, annual
C and semi-annual terms, and the linear and constant terms from
C the nutation co-ordinates, taking the time origin to be the original
C 44,089.99375 days. 
C 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      OPEN(UNIT=1,FILE='nut.dat',STATUS='OLD')
      OPEN(UNIT=2,FILE='nutres.dat',STATUS='UNKNOWN')
C Set constants.
      PI=3.14159265358979D0
      W=2.D0*PI/6798.58D0
      W9=2.D0*W
      WA=2.D0*PI/365.25971D0
      WSA=2.D0*WA
      AX=2.4496D0
      AY=1.9026D0
      BX=1.9307D0
      BY=-2.3741D0
      CX=-0.37214D0
      CY=-0.18244D0
      DX=-0.24779D0
      DY=0.13710D0
      EX=-1.0785D0
      EY=1.6863D0
      FX=1.7798D0
      FY=1.2533D0
      GX=0.82405D0
      GY=-0.17113D0
      HX=0.19983D0
      HY=0.71118D0
      AIX=-0.00324337D0
      AIY=-0.000665044D0
      AJX=150.02D0
      AJY=29.144D0
      DO 10,I=1,3343
           READ(1,11)J,DAY,XNUT,SEX,YNUT,SEY
 11      FORMAT(1X,I4,F15.6,4F10.3)
C Reset time origin.
           DAY=DAY+44089.99375D0
C Subtract 18.6-yr term, 9.3-yr term, annual and semi-annual terms,
C as well as linear and constant terms.
           XNUT=XNUT-AX*DCOS(W*DAY)-BX*DSIN(W*DAY)
     1     -CX*DCOS(W9*DAY)-DX*DSIN(W9*DAY)
     2     -EX*DCOS(WA*DAY)-FX*DSIN(WA*DAY)
     3     -GX*DCOS(WSA*DAY)-HX*DSIN(WSA*DAY)
     4     -AIX*DAY-AJX
           YNUT=YNUT-AY*DCOS(W*DAY)-BY*DSIN(W*DAY)
     1     -CY*DCOS(W9*DAY)-DY*DSIN(W9*DAY)
     2     -EY*DCOS(WA*DAY)-FY*DSIN(WA*DAY)
     3     -GY*DCOS(WSA*DAY)-HY*DSIN(WSA*DAY)
     4     -AIY*DAY-AJY
C Reset time origin for total record length of 8617 days.
           DAY=DAY-44089.99375D0+0.8618055D0
 10      WRITE(2,11)J,DAY,XNUT,SEX,YNUT,SEY
      END
